SystemOrganization addCategory: #'IRDA2013-sorting2-Challenges'!

Object subclass: #S2AbstractChallenge
	instanceVariableNames: 'sorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2AbstractChallenge class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:57:11.695'!
challengeDescription
	^'MyDescription'! !

!S2AbstractChallenge class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:57:28.472'!
challengeName
	^'MyName'! !

!S2AbstractChallenge class methodsFor: 'accessing' stamp: 'AT 5/27/2013 12:41:04.902'!
challengeNumber
	^nil! !

!S2AbstractChallenge class methodsFor: 'initializing' stamp: 'AT 5/27/2013 12:43:15.562'!
newWithNumber: nr
	|class|
	class := self.
	subclasses do: [:each |
		each challengeNumber = nr
		ifTrue: [class := each].  
	].
	^ (class new)! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:58:39.474'!
description
	^self class challengeName.! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:58:01.242'!
name
	^ self class challengeName.! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'AT 5/27/2013 12:37:30.193'!
number
	^challengeNumber! !

!S2AbstractChallenge methodsFor: 'signalling' stamp: 'AT 5/27/2013 13:47:07.364'!
onWin
	self halt.
	self emit.! !

!S2AbstractChallenge methodsFor: 'starting' stamp: 'AT 5/27/2013 12:59:16.155'!
setup: morph! !

!S2AbstractChallenge methodsFor: 'signalling' stamp: 'AT 5/27/2013 13:47:48.863'!
sorted
	self win! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'JB 6/10/2013 15:48:52.523'!
sorter
	^self subclassResponsibility.! !

!S2AbstractChallenge methodsFor: 'starting' stamp: 'AT 5/27/2013 12:27:58.434'!
start
	'instructions to set up the challenge UI'! !

!S2AbstractChallenge methodsFor: 'signalling' stamp: 'AT 5/27/2013 13:48:00.519'!
win
	self emit.! !

S2AbstractChallenge subclass: #S2AutomaticBubblesortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2AutomaticBubblesortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 6/10/2013 16:20:43.805'!
sorter
	^ S2BubbleSorter! !

S2AbstractChallenge subclass: #S2AutomaticQuickSortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2AutomaticQuickSortChallenge methodsFor: 'as yet unclassified' stamp: 'db 6/21/2013 03:20:10.612'!
sorter
	^S2QuickSorter! !

S2AbstractChallenge subclass: #S2Challenge1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2Challenge1 class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:56:36.502'!
challengeDescription
	'Do something'! !

!S2Challenge1 class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:56:21.99'!
challengeName
	^'Challenge 1: Sort the List'! !

!S2Challenge1 class methodsFor: 'accessing' stamp: 'AT 5/27/2013 12:41:26.714'!
challengeNumber
 ^1! !

!S2Challenge1 methodsFor: 'starting' stamp: 'db 6/17/2013 17:46:35.912'!
setup: morph
| listModel listMorph sorter b |
	
	listModel := S2ListModel new.
	listModel items: (1 to: 7) asOrderedCollection shuffled.
	
	listMorph := S2ListMorphOld new.
	"observer pattern"
	listModel addDependent: listMorph.
	listModel changed.
		
	sorter :=	S2BubbleSorter new.
	sorter model: listModel.
	self connect: sorter signal: #onSorted toSelector: #sorted. 
	
	morph addMorph: listMorph.
	listMorph position: morph position + (0@25).

	b := SimpleButtonMorph new.
	b color: Color green;
	label: 'Next Sort Step';
	target: sorter;
	actionSelector: #nextStep;
	setBalloonText: 'click to sort'.
	morph addMorph: b.
	b position: morph position! !

!S2Challenge1 methodsFor: 'starting' stamp: 'db 6/17/2013 17:46:39.964'!
start
| listModel listMorph sorter |
	
	listModel := S2ListModel new.
	listModel items: (1 to: 7) asOrderedCollection shuffled.
	
	listMorph := S2ListMorphOld new.
	"observer pattern"
	listModel addDependent: listMorph.
	listModel changed.
		
	sorter :=	S2BubbleSorter new.
	sorter model: listModel.
	
	"self showAlert: listMorph.

	b := SimpleButtonMorph new.
	b color: Color green;
	label: 'Next Sort Step';
	target: sorter;
	actionSelector: #nextStep;
	setBalloonText: 'click to sort'.
	self addMorph: b."! !

S2AbstractChallenge subclass: #S2FreeSortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2FreeSortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 6/10/2013 16:25:18.985'!
sorter
	sorter ifNil:[
		sorter := S2BubbleSorter new.].
	^ sorter! !

S2AbstractChallenge subclass: #S2ManualBubblesortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2ManualBubblesortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 6/10/2013 16:23:01.561'!
sorter
	sorter ifNil:[
		sorter := S2BubbleSorter new.].
	^ sorter! !
